!----------------------------------------------------------------------
!----------------------------------------------------------------------
!   tim :    A test problem for timing AUTO
!----------------------------------------------------------------------
!----------------------------------------------------------------------

      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
      DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

      INTEGER nd2,i,i1,i2
      DOUBLE PRECISION e, lambda
      DOUBLE PRECISION, EXTERNAL :: FEXP

       lambda = PAR(1)
       nd2=NDIM/2
       DO i=1,nd2
         i1=2*(i-1)+1
         i2=i1+1
         e=FEXP(U(i1))
         F(i1)=U(i2)
         F(i2)=-lambda*e
       ENDDO

      END SUBROUTINE FUNC
!----------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION FEXP(U)
!     ------ --------- -------- ----

      DOUBLE PRECISION, INTENT(IN) :: U

      INTEGER n,k
      DOUBLE PRECISION term

       n=25
       FEXP=1.d0
       term=FEXP
       DO k=1,n
        term=term*U/k
        FEXP=FEXP + term
       ENDDO

      END FUNCTION FEXP
!----------------------------------------------------------------------

      SUBROUTINE STPNT(NDIM,U,PAR,T)
!     ---------- -----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
      DOUBLE PRECISION, INTENT(IN) :: T

      INTEGER i

      DO i=1,NDIM
        U(i)=0.d0
      ENDDO

      END SUBROUTINE STPNT
!----------------------------------------------------------------------

      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC)
!     ---------- ----

      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM, ICP(*), NBC, IJAC
      DOUBLE PRECISION, INTENT(IN) :: PAR(*), U0(NDIM), U1(NDIM)
      DOUBLE PRECISION, INTENT(OUT) :: FB(NBC)
      DOUBLE PRECISION, INTENT(INOUT) :: DBC(NBC,*)

      INTEGER nd2,i,i1,i2

       nd2=NDIM/2
       DO i=1,nd2
         i1=2*(i-1)+1
         i2=i1+1
         FB(i1)=U0(i1)
         FB(i2)=U1(i1)
       ENDDO

      END SUBROUTINE BCND
!----------------------------------------------------------------------

      SUBROUTINE PVLS(NDIM,U,PAR)
!     ---------- ----
!
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
      DOUBLE PRECISION, EXTERNAL :: GETP

! Monitor the integral of the first component of U:
       PAR(9)=GETP('INT',1,U)   

      END SUBROUTINE PVLS
!----------------------------------------------------------------------

!----------------------------------------------------------------------

      SUBROUTINE ICND
      END SUBROUTINE ICND

      SUBROUTINE FOPT
      END SUBROUTINE FOPT
!----------------------------------------------------------------------
